Imports System.Net
Imports System.Net.Sockets
Imports System.IO
Imports System.Runtime.CompilerServices
Imports MVB = Microsoft.VisualBasic

#Const Use_IP_InputBox = False ' True  'check out, what will happen on changing it to True!

Public Module modHelpers

   Public Function GetIpEndPoint() As IPEndPoint
      '.AddressList() liefert verschiedene Addressen, sowohl im ipv4 als auch im v6-Format.
      'Als Standard-Vorbelegung (bzw Quick-Startup) wird die letzte ipv4-Format hergenommen.
      Dim DefaultIP As String = ""
      Dim addresses As IPAddress() = Dns.GetHostEntry(My.Computer.Name).AddressList
      Array.ForEach(addresses, Sub(adr) Debug.Print(adr.ToString))
      Array.Reverse(addresses)
      For Each addr As IPAddress In addresses
         If addr.AddressFamily = AddressFamily.InterNetwork Then
            DefaultIP = String.Concat(addr, " : 20000")
#If Not Use_IP_InputBox Then
            Return New IPEndPoint(addr, 20000)
#End If
            Exit For
         End If
      Next
      Dim InputIP As String = MVB.InputBox( _
         "( voreingestellt: eigene IP  und willkrlicher Port )", _
         "IP eingeben", _
         DefaultIP)
      Try
         'schlampige Fehlerbehandlung, weil ich zu faul bin, alle Mglichkeiten differenziert zu betrachten
         Dim Splitted As String() = InputIP.Split(":"c)
         Dim IPAs As IPAddress() = Dns.GetHostAddresses(Splitted(0))
         Return New IPEndPoint(IPAs(0), Integer.Parse(Splitted(1)))
      Catch ex As Exception
         Return Nothing
      End Try
   End Function


   <Extension> _
   Public Function ReadAllText(strm As Stream) As String
      Using rd = New StreamReader(strm)
         Return rd.ReadToEnd
      End Using
   End Function

   <Extension> _
   Public Sub WriteAllText(strm As Stream, txt As String)
      Using wr = New StreamWriter(strm)
         wr.Write(txt)
      End Using
   End Sub


End Module
